/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.interactions.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.hyades.models.common.common.CommonPackage;

import org.eclipse.hyades.models.common.common.impl.CommonPackageImpl;

import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;

import org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl;

import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;

import org.eclipse.hyades.models.common.fragments.impl.Common_Behavior_FragmentsPackageImpl;

import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRGeneralOrdering;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.BVRMessage;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;
import org.eclipse.hyades.models.common.interactions.BVRMessageSort;
import org.eclipse.hyades.models.common.interactions.BVRProperty;
import org.eclipse.hyades.models.common.interactions.BVRStateInvariant;
import org.eclipse.hyades.models.common.interactions.BVRStop;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsFactory;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;

import org.eclipse.hyades.models.common.testprofile.impl.Common_TestprofilePackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_Behavior_InteractionsPackageImpl extends EPackageImpl implements Common_Behavior_InteractionsPackage
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrLifelineEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrInteractionFragmentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrMessageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrGeneralOrderingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrEventOccurrenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrMessageEndEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrExecutionOccurrenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrStateInvariantEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrStopEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum bvrMessageSortEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private Common_Behavior_InteractionsPackageImpl()
	{
		super(eNS_URI, Common_Behavior_InteractionsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static Common_Behavior_InteractionsPackage init()
	{
		if (isInited) return (Common_Behavior_InteractionsPackage)EPackage.Registry.INSTANCE.get(Common_Behavior_InteractionsPackage.eNS_URI);
		isInited = true;

		// Obtain or create and register package and interdependencies
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(eNS_URI) : new Common_Behavior_InteractionsPackageImpl());
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)(EPackage.Registry.INSTANCE.get(CommonPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(CommonPackage.eNS_URI) : CommonPackageImpl.eINSTANCE);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)(EPackage.Registry.INSTANCE.get(Common_Behavior_FragmentsPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_Behavior_FragmentsPackage.eNS_URI) : Common_Behavior_FragmentsPackageImpl.eINSTANCE);
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)(EPackage.Registry.INSTANCE.get(Common_TestprofilePackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_TestprofilePackage.eNS_URI) : Common_TestprofilePackageImpl.eINSTANCE);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.get(Common_ConfigurationPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_ConfigurationPackage.eNS_URI) : Common_ConfigurationPackageImpl.eINSTANCE);

		// Step 1: create meta-model objects
		theCommon_Behavior_InteractionsPackage.createPackageContents();
		theCommonPackage.createPackageContents();
		theCommon_Behavior_FragmentsPackage.createPackageContents();
		theCommon_TestprofilePackage.createPackageContents();
		theCommon_ConfigurationPackage.createPackageContents();

		// Step 2: complete initialization
		theCommon_Behavior_InteractionsPackage.initializePackageContents();
		theCommonPackage.initializePackageContents();
		theCommon_Behavior_FragmentsPackage.initializePackageContents();
		theCommon_TestprofilePackage.initializePackageContents();
		theCommon_ConfigurationPackage.initializePackageContents();

		return theCommon_Behavior_InteractionsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRLifeline()
	{
		return bvrLifelineEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_InteractionFragments()
	{
		return (EReference)bvrLifelineEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_Instances()
	{
		return (EReference)bvrLifelineEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_PartDecomposition()
	{
		return (EReference)bvrLifelineEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_Interaction()
	{
		return (EReference)bvrLifelineEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRInteractionFragment()
	{
		return bvrInteractionFragmentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Lifelines()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_GeneralOrderings()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Messages()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Properties()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Interaction()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_DefaultApplication()
	{
		return (EReference)bvrInteractionFragmentEClass.getEReferences().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRMessage()
	{
		return bvrMessageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBVRMessage_MessageSort()
	{
		return (EAttribute)bvrMessageEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_ReceiveMessageEnd()
	{
		return (EReference)bvrMessageEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_SendMessageEnd()
	{
		return (EReference)bvrMessageEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_InteractionFragment()
	{
		return (EReference)bvrMessageEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_InstanceValues()
	{
		return (EReference)bvrMessageEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_Operation()
	{
		return (EReference)bvrMessageEClass.getEReferences().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRGeneralOrdering()
	{
		return bvrGeneralOrderingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRGeneralOrdering_PreviousEventOccurrence()
	{
		return (EReference)bvrGeneralOrderingEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRGeneralOrdering_NextEventOccurence()
	{
		return (EReference)bvrGeneralOrderingEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVREventOccurrence()
	{
		return bvrEventOccurrenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_TargetGeneralOrderings()
	{
		return (EReference)bvrEventOccurrenceEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_SourceGeneralOrderings()
	{
		return (EReference)bvrEventOccurrenceEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_FinishExecutionOccurrence()
	{
		return (EReference)bvrEventOccurrenceEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_StartExecutionOcurrence()
	{
		return (EReference)bvrEventOccurrenceEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRMessageEnd()
	{
		return bvrMessageEndEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessageEnd_ReceiveMessage()
	{
		return (EReference)bvrMessageEndEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessageEnd_SendMessage()
	{
		return (EReference)bvrMessageEndEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRExecutionOccurrence()
	{
		return bvrExecutionOccurrenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_FinishEventOccurrence()
	{
		return (EReference)bvrExecutionOccurrenceEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_BeforeEventOccurrence()
	{
		return (EReference)bvrExecutionOccurrenceEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_OtherBehavior()
	{
		return (EReference)bvrExecutionOccurrenceEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRStateInvariant()
	{
		return bvrStateInvariantEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRStop()
	{
		return bvrStopEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRProperty()
	{
		return bvrPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBVRProperty_Value()
	{
		return (EAttribute)bvrPropertyEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getBVRMessageSort()
	{
		return bvrMessageSortEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_InteractionsFactory getCommon_Behavior_InteractionsFactory()
	{
		return (Common_Behavior_InteractionsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents()
	{
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		bvrLifelineEClass = createEClass(BVR_LIFELINE);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INTERACTION_FRAGMENTS);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INSTANCES);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__PART_DECOMPOSITION);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INTERACTION);

		bvrInteractionFragmentEClass = createEClass(BVR_INTERACTION_FRAGMENT);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__LIFELINES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__GENERAL_ORDERINGS);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__MESSAGES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__PROPERTIES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__INTERACTION);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__DEFAULT_APPLICATION);

		bvrMessageEClass = createEClass(BVR_MESSAGE);
		createEAttribute(bvrMessageEClass, BVR_MESSAGE__MESSAGE_SORT);
		createEReference(bvrMessageEClass, BVR_MESSAGE__RECEIVE_MESSAGE_END);
		createEReference(bvrMessageEClass, BVR_MESSAGE__SEND_MESSAGE_END);
		createEReference(bvrMessageEClass, BVR_MESSAGE__INTERACTION_FRAGMENT);
		createEReference(bvrMessageEClass, BVR_MESSAGE__INSTANCE_VALUES);
		createEReference(bvrMessageEClass, BVR_MESSAGE__OPERATION);

		bvrGeneralOrderingEClass = createEClass(BVR_GENERAL_ORDERING);
		createEReference(bvrGeneralOrderingEClass, BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE);
		createEReference(bvrGeneralOrderingEClass, BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE);

		bvrEventOccurrenceEClass = createEClass(BVR_EVENT_OCCURRENCE);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE);

		bvrMessageEndEClass = createEClass(BVR_MESSAGE_END);
		createEReference(bvrMessageEndEClass, BVR_MESSAGE_END__RECEIVE_MESSAGE);
		createEReference(bvrMessageEndEClass, BVR_MESSAGE_END__SEND_MESSAGE);

		bvrExecutionOccurrenceEClass = createEClass(BVR_EXECUTION_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__FINISH_EVENT_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__BEFORE_EVENT_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__OTHER_BEHAVIOR);

		bvrStateInvariantEClass = createEClass(BVR_STATE_INVARIANT);

		bvrStopEClass = createEClass(BVR_STOP);

		bvrPropertyEClass = createEClass(BVR_PROPERTY);
		createEAttribute(bvrPropertyEClass, BVR_PROPERTY__VALUE);

		// Create enums
		bvrMessageSortEEnum = createEEnum(BVR_MESSAGE_SORT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents()
	{
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI);
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI);

		// Add supertypes to classes
		bvrLifelineEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());
		bvrInteractionFragmentEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());
		bvrEventOccurrenceEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrMessageEndEClass.getESuperTypes().add(this.getBVREventOccurrence());
		bvrExecutionOccurrenceEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrStateInvariantEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrStopEClass.getESuperTypes().add(this.getBVREventOccurrence());
		bvrPropertyEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());

		// Initialize classes and features; add operations and parameters
		initEClass(bvrLifelineEClass, BVRLifeline.class, "BVRLifeline", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVRLifeline_InteractionFragments(), this.getBVRInteractionFragment(), this.getBVRInteractionFragment_Lifelines(), "interactionFragments", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRLifeline_Instances(), theCommon_ConfigurationPackage.getCFGInstance(), theCommon_ConfigurationPackage.getCFGInstance_Lifeline(), "instances", null, 1, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRLifeline_PartDecomposition(), theCommon_Behavior_FragmentsPackage.getBVRPartDecomposition(), null, "partDecomposition", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRLifeline_Interaction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction_Lifelines(), "interaction", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrInteractionFragmentEClass, BVRInteractionFragment.class, "BVRInteractionFragment", IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVRInteractionFragment_Lifelines(), this.getBVRLifeline(), this.getBVRLifeline_InteractionFragments(), "lifelines", null, 1, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRInteractionFragment_GeneralOrderings(), this.getBVRGeneralOrdering(), null, "generalOrderings", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRInteractionFragment_Messages(), this.getBVRMessage(), this.getBVRMessage_InteractionFragment(), "messages", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRInteractionFragment_Properties(), this.getBVRProperty(), null, "properties", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRInteractionFragment_Interaction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction_InteractionFragments(), "interaction", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRInteractionFragment_DefaultApplication(), theCommon_TestprofilePackage.getTPFDefaultApplication(), theCommon_TestprofilePackage.getTPFDefaultApplication_InteractionFragment(), "defaultApplication", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrMessageEClass, BVRMessage.class, "BVRMessage", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getBVRMessage_MessageSort(), this.getBVRMessageSort(), "messageSort", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getBVRMessage_ReceiveMessageEnd(), this.getBVRMessageEnd(), this.getBVRMessageEnd_ReceiveMessage(), "receiveMessageEnd", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRMessage_SendMessageEnd(), this.getBVRMessageEnd(), this.getBVRMessageEnd_SendMessage(), "sendMessageEnd", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRMessage_InteractionFragment(), this.getBVRInteractionFragment(), this.getBVRInteractionFragment_Messages(), "interactionFragment", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRMessage_InstanceValues(), theCommon_TestprofilePackage.getTPFInstanceValue(), null, "instanceValues", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRMessage_Operation(), theCommon_ConfigurationPackage.getCFGOperation(), null, "operation", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrGeneralOrderingEClass, BVRGeneralOrdering.class, "BVRGeneralOrdering", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVRGeneralOrdering_PreviousEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_TargetGeneralOrderings(), "previousEventOccurrence", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRGeneralOrdering_NextEventOccurence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_SourceGeneralOrderings(), "nextEventOccurence", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrEventOccurrenceEClass, BVREventOccurrence.class, "BVREventOccurrence", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVREventOccurrence_TargetGeneralOrderings(), this.getBVRGeneralOrdering(), this.getBVRGeneralOrdering_PreviousEventOccurrence(), "targetGeneralOrderings", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVREventOccurrence_SourceGeneralOrderings(), this.getBVRGeneralOrdering(), this.getBVRGeneralOrdering_NextEventOccurence(), "sourceGeneralOrderings", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVREventOccurrence_FinishExecutionOccurrence(), this.getBVRExecutionOccurrence(), this.getBVRExecutionOccurrence_FinishEventOccurrence(), "finishExecutionOccurrence", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVREventOccurrence_StartExecutionOcurrence(), this.getBVRExecutionOccurrence(), this.getBVRExecutionOccurrence_BeforeEventOccurrence(), "startExecutionOcurrence", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrMessageEndEClass, BVRMessageEnd.class, "BVRMessageEnd", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVRMessageEnd_ReceiveMessage(), this.getBVRMessage(), this.getBVRMessage_ReceiveMessageEnd(), "receiveMessage", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRMessageEnd_SendMessage(), this.getBVRMessage(), this.getBVRMessage_SendMessageEnd(), "sendMessage", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrExecutionOccurrenceEClass, BVRExecutionOccurrence.class, "BVRExecutionOccurrence", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getBVRExecutionOccurrence_FinishEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_FinishExecutionOccurrence(), "finishEventOccurrence", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRExecutionOccurrence_BeforeEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_StartExecutionOcurrence(), "beforeEventOccurrence", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getBVRExecutionOccurrence_OtherBehavior(), theCommon_TestprofilePackage.getTPFBehavior(), null, "otherBehavior", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(bvrStateInvariantEClass, BVRStateInvariant.class, "BVRStateInvariant", !IS_ABSTRACT, !IS_INTERFACE);

		initEClass(bvrStopEClass, BVRStop.class, "BVRStop", !IS_ABSTRACT, !IS_INTERFACE);

		initEClass(bvrPropertyEClass, BVRProperty.class, "BVRProperty", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getBVRProperty_Value(), ecorePackage.getEString(), "value", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);

		// Initialize enums and add enum literals
		initEEnum(bvrMessageSortEEnum, BVRMessageSort.class, "BVRMessageSort");
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.SYNCH_CALL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.SYNCH_SIGNAL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.ASYNCH_CALL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.ASYNCH_SIGNAL_LITERAL);
	}
} //Common_Behavior_InteractionsPackageImpl
